using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace WeaponMod
{
    public class WeaponMod
    {
        public static void Main()
        {                   

             //Xenomoprh
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Android"),
                    NameOverride = "Xenomorph  -AVP",
                    NameToOrderByOverride = "MMM",
                    DescriptionOverride = "He's the Alien",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("4.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var skin = ModAPI.LoadTexture("xeno.png");  
                        var meat = ModAPI.LoadTexture("xeno_meat.png");
                        var bone = ModAPI.LoadTexture("xeno_bone.png");          
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, meat, bone, 1);


                        GameObject Tail = GameObject.Instantiate(Instance.transform.Find("FrontLeg").gameObject);
            Instance.transform.Find("Body").GetChild(2).gameObject.GetComponent<LimbBehaviour>().ConnectedLimbs.Add(Tail.transform.GetChild(0).gameObject.GetComponent<LimbBehaviour>());
            CirculationBehaviour[] PushThing = Instance.transform.Find("Body").GetChild(2).gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.PushesTo;
            Instance.transform.Find("Body").GetChild(2).gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.PushesTo = new CirculationBehaviour[] { PushThing[0], PushThing[1], Tail.transform.GetChild(0).gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour };
            Tail.transform.GetChild(0).gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.PushesTo = new CirculationBehaviour[] { Tail.transform.GetChild(1).gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour };
            //     [Instance.transform.Find("Body").GetChild(2).gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.PushesTo.Length + 1] = Tail.transform.GetChild(0).gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour;
            // (Tail.transform.GetChild(0).gameObject.GetComponent<LimbBehaviour>())
            Tail.transform.GetChild(0).gameObject.GetComponent<LimbBehaviour>().Joint.connectedBody = Instance.transform.Find("Body").GetChild(2).gameObject.GetComponent<Rigidbody2D>();
            Tail.transform.GetChild(0).gameObject.GetComponent<LimbBehaviour>().Joint.useLimits = false;
            Tail.transform.GetChild(1).gameObject.GetComponent<LimbBehaviour>().Joint.useLimits = false;
            Tail.transform.SetParent(Instance.transform);
            GameObject.Destroy(Tail.transform.GetChild(2).gameObject);
            Tail.transform.GetChild(1).GetComponent<LimbBehaviour>().SkinMaterialHandler.renderer.color = Color.black;
            Tail.transform.GetChild(0).GetComponent<LimbBehaviour>().SkinMaterialHandler.renderer.color = Color.black;
            if (Instance.transform.localScale.x < 0)
            {

                Tail.transform.position = Instance.transform.position - (-Vector3.right * 0.16f);
                Tail.transform.localScale = new Vector3(-Tail.transform.localScale.x, Tail.transform.localScale.y, Tail.transform.localScale.z);

            }
            else Tail.transform.position = Instance.transform.position + (-Vector3.right * 0.16f);

            GameObject TailStabby = GameObject.Instantiate(ModAPI.FindSpawnable("Knife").Prefab);
            TailStabby.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("TailTip.png");
            TailStabby.transform.position = Tail.transform.GetChild(1).position - (Tail.transform.GetChild(1).transform.up * 0.3f);
            TailStabby.transform.eulerAngles = Tail.transform.GetChild(1).eulerAngles + new Vector3(0,0,180);
            Tail.transform.GetChild(1).gameObject.AddComponent<FixedJoint2D>().connectedBody = TailStabby.GetComponent<Rigidbody2D>();
            Tail.transform.GetChild(1).transform.localScale = new Vector3(Tail.transform.GetChild(1).transform.localScale.x /2, Tail.transform.GetChild(1).transform.localScale.y, Tail.transform.GetChild(1).transform.localScale.z);
            Tail.transform.GetChild(0).transform.localScale = new Vector3(Tail.transform.GetChild(0).transform.localScale.x /2, Tail.transform.GetChild(0).transform.localScale.y, Tail.transform.GetChild(0).transform.localScale.z);
            TailStabby.transform.SetParent(Tail.transform.GetChild(1).transform);


                        person.SetBruiseColor(108, 0, 4); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(108, 0, 4); //second bruise colour. red by default
                        person.SetThirdBruiseColor(108, 0, 4); // third bruise colour. light yellow by default
                        person.SetBloodColour(0, 100, 4); // blood clour. dark red by default
                        person.SetRottenColour(0, 0, 0); // rotten/zombie colour. light yellow/green by default
                        foreach (var body in person.Limbs)
                        {

                             body.BaseStrength *= 3f;                          
                             body.Health *= 500f;
                             body.BreakingThreshold *= 12f;
                             body.transform.root.localScale *= 1f; 
                             body.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Gorse");                                            
                             var arm1 = Instance.transform.Find("Head");
                             var phys1 = arm1.GetComponent<PhysicalBehaviour>();
                             var prop1 = ModAPI.FindPhysicalProperties("Human");
                             prop1.Sharp = true;
                             prop1.SharpAxes = new[]
                             {
                                 new SharpAxis(Vector2.right, 0f, 0.29f, true, true),
                             };
                             phys1.Properties = prop1;

                             body.GetComponent<PhysicalBehaviour>().OverrideImpactSounds = new AudioClip[] 
                             {
                                                          ModAPI.LoadSound("a1.wav"),
                                                          ModAPI.LoadSound("a2.wav"),
                                                          ModAPI.LoadSound("a3.wav"),
                                                          ModAPI.LoadSound("a4.wav"), 
                                                          ModAPI.LoadSound("a5.wav"),
                                                          ModAPI.LoadSound("a6.wav"),                                                                                 
                                                        }; 
                             var ca = new GameObject("ca");
                             ca.transform.SetParent(Instance.transform.Find("Head"));
                             ca.transform.localPosition = new Vector3(-0.30f, -0.03f, 0f);
                             ca.transform.localScale = new Vector3(1f, 1f);
                             var caSprite = ca.AddComponent<SpriteRenderer>();
                             caSprite.sprite = ModAPI.LoadSprite("head.png"); 
                             ca.GetComponent<SpriteRenderer>().sortingLayerName = "Top";

                             var heady = Instance.transform.Find("Head");

                             heady.localPosition = new Vector3(0.15f, 0.70f, 0f);
 
                             body.GetComponent<PhysicalBehaviour>().ReflectsLasers = true;  
                             var backpack = new GameObject("Backpack");
                             backpack.transform.SetParent(Instance.transform.Find("Body").Find("MiddleBody"));
                             backpack.transform.localPosition = new Vector3(0, 0f);
                             backpack.transform.localScale = new Vector3(1f, 1f);
                             var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                             backpackSprite.sprite = ModAPI.LoadSprite("Spike.png"); 
                     
                             var hand1 = new GameObject("hand1");
                             hand1.transform.SetParent(Instance.transform.Find("FrontArm").Find("LowerArmFront"));
                             hand1.transform.localPosition = new Vector3(0, 0f);
                             hand1.transform.localScale = new Vector3(1f, 1f);
                             var hand1Sprite = hand1.AddComponent<SpriteRenderer>();
                             hand1Sprite.sprite = ModAPI.LoadSprite("sharp.png");  

                             var hand2 = new GameObject("hand2");
                             hand2.transform.SetParent(Instance.transform.Find("BackArm").Find("LowerArm"));
                             hand2.transform.localPosition = new Vector3(0, 0f);
                             hand2.transform.localScale = new Vector3(1f, 1f);
                             var hand2Sprite = hand2.AddComponent<SpriteRenderer>();
                             hand2Sprite.sprite = ModAPI.LoadSprite("sharp.png");  

                             var foot1 = new GameObject("foot1");
                             foot1.transform.SetParent(Instance.transform.Find("FrontLeg").Find("FootFront"));
                             foot1.transform.localPosition = new Vector3(0, 0f);
                             foot1.transform.localScale = new Vector3(1f, 1f);
                             var foot1Sprite = foot1.AddComponent<SpriteRenderer>();
                             foot1Sprite.sprite = ModAPI.LoadSprite("foot.png");   

                             var foot2 = new GameObject("foot2");
                             foot2.transform.SetParent(Instance.transform.Find("BackLeg").Find("Foot"));
                             foot2.transform.localPosition = new Vector3(0, 0f);
                             foot2.transform.localScale = new Vector3(1f, 1f);
                             var foot2Sprite = foot2.AddComponent<SpriteRenderer>();
                             foot2Sprite.sprite = ModAPI.LoadSprite("foot.png");  

                            var Heads = Instance.transform.Find("Head").gameObject;
                            foreach(var hitbox1 in Heads.GetComponents<Collider2D>()) { GameObject.Destroy(hitbox1); }
                            var floop1 = Heads.AddComponent<BoxCollider2D>();

                            floop1.offset = new Vector2(-0.1f, 0.1f);
                            floop1.size = new Vector3(0.75f, 0.3f);                                                     

                        }                    
                    }
                }
            ); 

            //Predator
               ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Android"),
                    NameOverride = "Predator (Yautja) -AVP",
                    NameToOrderByOverride = "A",
                    DescriptionOverride = "The Hunter.. the mighty",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("1.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var skin = ModAPI.LoadTexture("pred.png");
                        var s = ModAPI.LoadTexture("r.png"); 
                        var se = ModAPI.LoadTexture("re.png");                        
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, s, se, 1);
                        person.SetBruiseColor(108, 0, 4); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(108, 0, 4); //second bruise colour. red by default
                        person.SetThirdBruiseColor(108, 0, 4); // third bruise colour. light yellow by default
                        person.SetBloodColour(108, 0, 4); // blood clour. dark red by default
                        person.SetRottenColour(0, 0, 0); // rotten/zombie colour. light yellow/green by default
                        foreach (var body in person.Limbs)
                        {
                             body.GetComponent<PhysicalBehaviour>().StabCausesWound = true;
                             body.BaseStrength *= 2f;                          
                             body.Health *= 450f;
                             body.BreakingThreshold *= 12f;
                             body.transform.root.localScale *= 0.995f; 
                             body.ShotDamageMultiplier *= 0f;
                             body.Vitality *= 4.5f;
                             body.ImpactPainMultiplier *= 0f;
                             body.Numbness *= 2f;
                             body.GetComponent<PhysicalBehaviour>().OverrideImpactSounds = new AudioClip[] 
                             {
                                                          ModAPI.LoadSound("01.wav"),
                                                          ModAPI.LoadSound("02.wav"),
                                                          ModAPI.LoadSound("03.wav"),
                                                          ModAPI.LoadSound("04.wav"), 
                                                          ModAPI.LoadSound("05.mp3"),                                                                                 
                                                        }; 
                             
                             body.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Gorse");
                             var someobject = new GameObject("someobject");
                             someobject.transform.SetParent(Instance.transform.Find("Head"));
                             someobject.transform.localPosition = new Vector3(0, 0f);
                             someobject.transform.localScale = new Vector3(1f, 1f);
                             var someobjectSprite = someobject.AddComponent<SpriteRenderer>();
                             someobjectSprite.sprite = ModAPI.LoadSprite("mask.png"); 
                             someobject.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                             int toggle = 0;
                             someobject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("mask.png");
                        someobject.AddComponent<UseEventTrigger>().Action = () => { 
                        //Changes the sprite when active
                        if(toggle == 0){
                            toggle = 1;
                                                        someobject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("none.png");

                        }else{
                            toggle = 0;
                                                        someobject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("mask.png");


                        }
                        



                        
                        };
                                                                                  

                        }                    
                    }
                }
            ); 

             //predator
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Knife"), 
                    NameOverride = "Predator Wrist Blades -AVP", // Name.
                    NameToOrderByOverride = "AA1", //  
                    DescriptionOverride = "Very Brutal Weapon",// Description
                    CategoryOverride = ModAPI.FindCategory("Melee"),//Category
                    ThumbnailOverride = ModAPI.LoadSprite("7.png", 5f),//Thumbnail
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("hey.png", 1f);
                        Instance.FixColliders();

                    }
                }
            );

             //Marine
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Marine  -AVP",
                    NameToOrderByOverride = "A",
                    DescriptionOverride = "Very Brave marine.",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("2.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var skin = ModAPI.LoadTexture("marine.png");                       
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, null, null, 1);
                        person.SetBruiseColor(108, 0, 4); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(108, 0, 4); //second bruise colour. red by default
                        person.SetThirdBruiseColor(108, 0, 4); // third bruise colour. light yellow by default
                        person.SetBloodColour(108, 0, 4); // blood clour. dark red by default
                        person.SetRottenColour(0, 0, 0); // rotten/zombie colour. light yellow/green by default
                        foreach (var body in person.Limbs)
                        {
                             body.BaseStrength *= 1f;                          
                             body.Health *= 5f;
                             body.BreakingThreshold *= 1f;                                                   
                        }                    
                    }
                }
            ); 

             //Pulse Rifle
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Vector"),
                    NameOverride = "Pulse Rifle  -AVP",
                    NameToOrderByOverride = "PPPP",
                    DescriptionOverride = "With its iconic sound",
                    CategoryOverride = ModAPI.FindCategory("Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite("5.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("pulse.png", 1.05f);
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.5f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.5f;
                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        Cartridge customCartridge = ModAPI.FindCartridge("7.62x39mm");
                        customCartridge.name = "5.45x39mm";
                        customCartridge.Damage *= 0.01f; 
                        customCartridge.StartSpeed *= 1f;
                        customCartridge.Recoil *= 0.2f;
                        firearm.Cartridge = customCartridge;
                        Instance.AddComponent<UseEventTrigger>().Action = () => {          
                        ModAPI.CreateParticleEffect("MetalHit", Instance.transform.position);
                                                                              };

                         firearm.ShotSounds = new AudioClip[]
                        {
                         ModAPI.LoadSound("1.wav"),
                         ModAPI.LoadSound("2.wav"),
                         ModAPI.LoadSound("3.wav"),
                         ModAPI.LoadSound("4.wav"),
                        };

                        Instance.FixColliders();


                    }
                }
            );

             //predator
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"), 
                    NameOverride = "Tracking Device (nostromo)", // Name.
                    NameToOrderByOverride = "AA1", //  
                    DescriptionOverride = "Press F for the Beep sound",// Description 
                    CategoryOverride = ModAPI.FindCategory("Misc."),//Category
                    ThumbnailOverride = ModAPI.LoadSprite("6.png", 5f),//Thumbnail
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("track.png", 1f);
                        Instance.FixColliders();                      
                        AudioSource audioSource;
                 AudioClip sound;
                             Instance.AddComponent<UseEventTrigger>().Action = () => { 
                             sound = ModAPI.LoadSound("beep.wav");
                            audioSource = Instance.AddComponent<AudioSource>();
                            audioSource.minDistance = 2;
                            audioSource.maxDistance = 50;
                            audioSource.clip = sound;
                            audioSource.Play();
                                                        audioSource.volume = 1f;
                                                                                    };

                    }
                }
            );
           //Marine2
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Marine with armor  -AVP",
                    NameToOrderByOverride = "A",
                    DescriptionOverride = "better with armor",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("3.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var skin = ModAPI.LoadTexture("marine2.png");                       
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, null, null, 1);
                        person.SetBruiseColor(108, 0, 4); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(108, 0, 4); //second bruise colour. red by default
                        person.SetThirdBruiseColor(108, 0, 4); // third bruise colour. light yellow by default
                        person.SetBloodColour(108, 0, 4); // blood clour. dark red by default
                        person.SetRottenColour(0, 0, 0); // rotten/zombie colour. light yellow/green by default
                        foreach (var body in person.Limbs)
                        {
                             body.BaseStrength *= 1f;                          
                             body.Health *= 5f;
                             body.BreakingThreshold *= 1f; 
                             var ca = new GameObject("ca");
                             ca.transform.SetParent(Instance.transform.Find("Head"));
                             ca.transform.localPosition = new Vector3(0f, 0.06f, 0f);
                             ca.transform.localScale = new Vector3(1f, 1f);
                             var caSprite = ca.AddComponent<SpriteRenderer>();
                             caSprite.sprite = ModAPI.LoadSprite("helm.png"); 
                             ca.GetComponent<SpriteRenderer>().sortingLayerName = "Top";                                                  
                        }                    
                    }
                }
            ); 
             //flashlight
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Flashlight"), 
                    NameOverride = "Flashlight from Alien -AVP", // Name.
                    NameToOrderByOverride = "AA1", //  
                    DescriptionOverride = "Very strange flashlight but it works",// Description
                    CategoryOverride = ModAPI.FindCategory("Machinery"),//Category
                    ThumbnailOverride = ModAPI.LoadSprite("8.png", 5f),//Thumbnail
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("flashyo2.png");
                        Instance.AddComponent<AudioSource>();

                        var breath = new GameObject("breath");
                             breath.transform.SetParent(Instance.transform);
                             breath.transform.localPosition = new Vector3(0, 0f);
                             breath.transform.localScale = new Vector3(1f, 1f);
                             var breathSprite = breath.AddComponent<SpriteRenderer>();
                             breathSprite.sprite = ModAPI.LoadSprite("flashyo2.png"); 
                             breath.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                             int toggle = 0;
                        breath.AddComponent<UseEventTrigger>().Action = () => { 
                        //Changes the sprite when active
                        if(toggle == 0){
                            toggle = 1;
                                                        breath.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("flashyo.png");
                                                        ModAPI.LoadSound("press.wav");



                        }else{
                            toggle = 0;
                                                        breath.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("flashyo2.png");


                        }
                        



                        
                        };
                    }
                }
            );

             //FlameThrower
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Flamethrower"), 
                    NameOverride = "FlameThrower -Avp", // Name.
                    NameToOrderByOverride = "AA1", //  
                    DescriptionOverride = "Dangerous Weapon against everyone",// Description 
                    CategoryOverride = ModAPI.FindCategory("Firearms"),//Category
                    ThumbnailOverride = ModAPI.LoadSprite("10.png", 5f),//Thumbnail
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("flame.png", 1.2f);
                        Instance.FixColliders();  
                        Instance.GetComponent<FlamethrowerBehaviour>().IgnitionSound = ModAPI.LoadSound("flame.wav"); 
                        AudioSource audioSource;
                 AudioClip sound;
                             Instance.AddComponent<UseEventTrigger>().Action = () => { 
                             sound = ModAPI.LoadSound("flame.wav");
                            audioSource = Instance.AddComponent<AudioSource>();
                            audioSource.minDistance = 2;
                            audioSource.maxDistance = 50;
                            audioSource.clip = sound;
                            audioSource.Play();
                                                        audioSource.volume = 1f;
                                                                                    };                   

                    }
                }
            );

            //spear
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Spear"), 
                    NameOverride = "Combistick -Avp", // Name.
                    NameToOrderByOverride = "AA1", //  
                    DescriptionOverride = "Predators spear",// Description 
                    CategoryOverride = ModAPI.FindCategory("Melee"),//Category
                    ThumbnailOverride = ModAPI.LoadSprite("9.png", 5f),//Thumbnail
                    AfterSpawn = (Instance) =>
                    {

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("spear.png", 1.1f);
                        Instance.FixColliders();                      

                    }
                }
            );
            //Plasma Caster
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Blaster Rifle"), 
                    NameOverride = "Plasma Caster -Avp", // Name.
                    NameToOrderByOverride = "AA1", //  
                    DescriptionOverride = "Predators have this on their shoulder (disable collisions)",// Description 
                    CategoryOverride = ModAPI.FindCategory("Firearms"),//Category
                    ThumbnailOverride = ModAPI.LoadSprite("27.png", 5f),//Thumbnail
                    AfterSpawn = (Instance) =>
                    {

                        UnityEngine.Object.Destroy(Instance.transform.GetChild(0).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(1).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(2).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(3).gameObject);
                                                
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("cast.png", 1.3f);
                        Instance.FixColliders();   
                        Instance.GetComponent<BlasterBehaviour>().Interval = 2f;
                        Instance.GetComponent<BlasterboltBehaviour>().Speed = 5f;
                        Instance.GetComponent<BlasterBehaviour>().Clips = new AudioClip[]
                        {
                            ModAPI.LoadSound("shoot.wav")                         
                        };                   

                    }
                }
            );
            
           //Facehugger Egg
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Plastic Barrel"), 
                    NameOverride = "Facehugger Egg -Avp", // Name.
                    NameToOrderByOverride = "AA1", //  
                    DescriptionOverride = "press f on it to hatch it",// Description 
                    CategoryOverride = ModAPI.FindCategory("Misc."),//Category
                    ThumbnailOverride = ModAPI.LoadSprite("11.png", 5f),//Thumbnail
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("egg.png", 1f);
                        Instance.AddComponent<podarokfake>();
                        Instance.AddComponent<podarokfake2>();                 
                        Instance.FixColliders(); 
                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Gorse");
                        int toggle = 0;
                             Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("egg.png");
                        Instance.AddComponent<UseEventTrigger>().Action = () => {   
                        //Changes the sprite when active
                        if(toggle == 0){
                            toggle = 1;
                                                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("egg2.png");
                                                        ModAPI.FindSpawnable("Facehugger (custom model) -AVP");

                        }else{
                            toggle = 0;
                                                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("egg2.png");


                        }
                        



                        
                        };                     

                    }
                }
            );
         //Alien Block
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Plastic Barrel"), 
                    NameOverride = "Alien Nest Block -Avp", // Name.
                    NameToOrderByOverride = "AA1", //  
                    DescriptionOverride = "They build their bases with these",// Description 
                    CategoryOverride = ModAPI.FindCategory("Misc."),//Category
                    ThumbnailOverride = ModAPI.LoadSprite("12.png", 5f),//Thumbnail
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("block.png", 1f);
                        Instance.FixColliders();                      

                    }
                }
            );
            //Alien Trap
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Plastic Barrel"), 
                    NameOverride = "Alien Trap -Avp", // Name.
                    NameToOrderByOverride = "AA1", //  
                    DescriptionOverride = "Wait For The Egg",// Description 
                    CategoryOverride = ModAPI.FindCategory("Misc."),//Category
                    ThumbnailOverride = ModAPI.LoadSprite("24.png", 5f),//Thumbnail
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Alien Trap.png", 1.5f);
                        Instance.FixColliders();   
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";                   

                    }
                }
            );
              //Jungle Vine
                ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Plastic Barrel"), 
                    NameOverride = "Jungle Vine -Avp", // Name.
                    NameToOrderByOverride = "AA1", //  
                    DescriptionOverride = "Jungle vines",// Description 
                    CategoryOverride = ModAPI.FindCategory("Misc."),//Category
                    ThumbnailOverride = ModAPI.LoadSprite("13.png", 5f),//Thumbnail
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("vine.png", 1f);
                        Instance.FixColliders();                      

                    }
                }
            );

                ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Car"),
                    NameOverride = "Military Jeep  -AVP",
                    NameToOrderByOverride = "car",
                    DescriptionOverride = "Dont Steal his car",
                    CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    ThumbnailOverride = ModAPI.LoadSprite("14.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                            ModAPI.LoadSprite("jeep.png", 1f),
                        };
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 15f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 15f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 15f;
                        Instance.FixColliders();
                    }
                }
            );
                                ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Car"),
                    NameOverride = "APC  -AVP",
                    NameToOrderByOverride = "car",
                    DescriptionOverride = "Dont Steal his car",
                    CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    ThumbnailOverride = ModAPI.LoadSprite("28.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                            ModAPI.LoadSprite("APC.png", 1f),
                        };
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 15f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 15f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 15f;
                        Instance.FixColliders();
                    }
                }
            );
         //Facehugger
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Gorse"),
                    NameOverride = "Facehugger (Gorse Model) -AVP",
                    NameToOrderByOverride = "A",
                    DescriptionOverride = "Watch OUT",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("16.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var skin = ModAPI.LoadTexture("Facee.png");  
                        var meat = ModAPI.LoadTexture("Facee_meat.png");                     
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, meat, null, 1);
                        person.SetBruiseColor(108, 0, 4); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(108, 0, 4); //second bruise colour. red by default
                        person.SetThirdBruiseColor(108, 0, 4); // third bruise colour. light yellow by default
                        person.SetBloodColour(108, 0, 4); // blood clour. dark red by default
                        person.SetRottenColour(0, 0, 0); // rotten/zombie colour. light yellow/green by default
                        foreach (var body in person.Limbs)
                        {
                             body.BaseStrength *= 0.5f;                          
                             body.Health *= 5f;
                             body.BreakingThreshold *= 1f;  
                             body.transform.root.localScale *= 0.9f;
                             var shooty = Instance.transform.GetChild(0).GetChild(0).gameObject;
                             GameObject.Destroy(shooty);    
                             var tail = new GameObject("tail");
                             tail.transform.SetParent(Instance.transform.Find("body"));
                             tail.transform.localPosition = new Vector3(0f, 0.15f);
                             tail.transform.localScale = new Vector3(1f, 1f);
                             var tailSprite = tail.AddComponent<SpriteRenderer>();
                             tailSprite.sprite = ModAPI.LoadSprite("taily.png"); 
                                                                      
                        }                    
                      }
                    }
                 ); 

        //Facehugger
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Android"),
                    NameOverride = "Facehugger (custom model) -AVP",
                    NameToOrderByOverride = "A",
                    DescriptionOverride = "Lay some eggs",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("15.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var skin = ModAPI.LoadTexture("Facee2.png");    
                        var meat = ModAPI.LoadTexture("Facee2_meat.png");
                        var bone = ModAPI.LoadTexture("Facee2_meat.png");                   
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, meat, bone, 1);
                        person.SetBruiseColor(108, 0, 4); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(108, 0, 4); //second bruise colour. red by default
                        person.SetThirdBruiseColor(108, 0, 4); // third bruise colour. light yellow by default
                        person.SetBloodColour(108, 0, 4); // blood clour. dark red by default
                        person.SetRottenColour(0, 0, 0); // rotten/zombie colour. light yellow/green by default
                        foreach (var body in person.Limbs)
                        {
                             body.BaseStrength *= 0.5f;                          
                             body.Health *= 5f;
                             body.BreakingThreshold *= 1f;  
                             body.transform.root.localScale *= 1.01f;
                             body.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Gorse");
                             body.GetComponent<PhysicalBehaviour>().OverrideImpactSounds = new AudioClip[] 
                             {
                                                          ModAPI.LoadSound("a1.wav"),
                                                          ModAPI.LoadSound("a2.wav"),
                                                          ModAPI.LoadSound("a3.wav"),
                                                          ModAPI.LoadSound("a4.wav"), 
                                                          ModAPI.LoadSound("a5.wav"),
                                                          ModAPI.LoadSound("a6.wav"),                                                                                 
                                                        }; 

                             var tail = new GameObject("tail");
                             tail.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
                             tail.transform.localPosition = new Vector3(-0.46f, -0.155f);
                             tail.transform.localScale = new Vector3(1f, 1f);
                             var tailSprite = tail.AddComponent<SpriteRenderer>();
                             tailSprite.sprite = ModAPI.LoadSprite("tal.png");


                            var legLeft = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
                            var legRight = Instance.transform.Find("BackLeg").Find("UpperLeg");

                            legLeft.localPosition = new Vector3(0f, -0.25f, 0f);
                            legRight.localPosition = new Vector3(0.11f, -0.25f, 0f);
                           

                            legLeft.localScale = Vector2.one * 0.2f;
                            legRight.localScale = Vector2.one * 0.2f;

                            Instance.transform.Find("BackArm").Find("UpperArm").gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                            Instance.transform.Find("BackArm").Find("LowerArm").gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                            Instance.transform.Find("FrontArm").Find("UpperArmFront").gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                            Instance.transform.Find("FrontArm").Find("LowerArmFront").gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                            Instance.transform.Find("Body").Find("UpperBody").gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                            Instance.transform.Find("Body").Find("MiddleBody").gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                            Instance.transform.Find("Head").gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                            Instance.transform.Find("BackLeg").Find("LowerLeg").gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                            Instance.transform.Find("FrontLeg").Find("LowerLegFront").gameObject.GetComponent<PhysicalBehaviour>().Disintegrate(); 
                            Instance.transform.Find("BackLeg").Find("Foot").gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                            Instance.transform.Find("FrontLeg").Find("FootFront").gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();                       
                        }

                        var fleebHead = Instance.transform.Find("Body").Find("LowerBody").gameObject;
                        fleebHead.name = "Head"; //this is so it works with the armor mod :)
                        fleebHead.GetComponent<LimbBehaviour>().HasBrain = true;
                        fleebHead.GetComponent<CirculationBehaviour>().WasInitiallyPumping = true;
                        fleebHead.GetComponent<CirculationBehaviour>().IsPump = true;

                        foreach(var hitbox in fleebHead.GetComponents<Collider2D>()) { GameObject.Destroy(hitbox); }
                        var floop = fleebHead.AddComponent<BoxCollider2D>();
                        floop.offset = new Vector2(-0.3f, -0.1f);
                        floop.size = new Vector3(0.8f, 0.1f);

                        var fleebth = fleebHead.AddComponent<GripBehaviour>();
                        fleebth.GripPosition = new Vector3(0.15f, -0.15f, 0.45f);   
                                                                                                                  
                  }
              }
          ); 
//ChestBurster
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "ChestBurster -AVP",
                    NameToOrderByOverride = "A",
                    DescriptionOverride = "this guy is not really dangerous",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("25.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var skin = ModAPI.LoadTexture("chest.png");                       
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, skin, skin, 1);
                        person.SetBruiseColor(108, 0, 4); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(108, 0, 4); //second bruise colour. red by default
                        person.SetThirdBruiseColor(108, 0, 4); // third bruise colour. light yellow by default
                        person.SetBloodColour(108, 0, 4); // blood clour. dark red by default
                        person.SetRottenColour(0, 0, 0); // rotten/zombie colour. light yellow/green by default
                        foreach (var body in person.Limbs)
                        {
                             body.BaseStrength *= 0.5f;                          
                             body.Health *= 0.5f;
                             body.BreakingThreshold *= 50f;  
                             body.transform.root.localScale *= 1.01f;
                             body.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Gorse");

                             var tail = new GameObject("tail");
                             tail.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
                             tail.transform.localPosition = new Vector3(-0.46f, 0.05f);
                             tail.transform.localScale = new Vector3(1f, 1f);
                             var tailSprite = tail.AddComponent<SpriteRenderer>();
                             tailSprite.sprite = ModAPI.LoadSprite("2ndpart.png");


                            Instance.transform.Find("BackArm").Find("UpperArm").gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                            Instance.transform.Find("BackArm").Find("LowerArm").gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                            Instance.transform.Find("FrontArm").Find("UpperArmFront").gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                            Instance.transform.Find("FrontArm").Find("LowerArmFront").gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                            Instance.transform.Find("Body").Find("UpperBody").gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                            Instance.transform.Find("Body").Find("MiddleBody").gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                            Instance.transform.Find("Head").gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                            Instance.transform.Find("BackLeg").Find("LowerLeg").gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                            Instance.transform.Find("FrontLeg").Find("LowerLegFront").gameObject.GetComponent<PhysicalBehaviour>().Disintegrate(); 
                            Instance.transform.Find("BackLeg").Find("Foot").gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                            Instance.transform.Find("FrontLeg").Find("FootFront").gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();  
                            Instance.transform.Find("FrontLeg").Find("UpperLegFront").gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                            Instance.transform.Find("BackLeg").Find("UpperLeg").gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();                      
                        }

                        var fleebHead = Instance.transform.Find("Body").Find("LowerBody").gameObject;
                        fleebHead.name = "Head"; //this is so it works with the armor mod :)
                        fleebHead.GetComponent<LimbBehaviour>().HasBrain = true;
                        fleebHead.GetComponent<CirculationBehaviour>().WasInitiallyPumping = true;
                        fleebHead.GetComponent<CirculationBehaviour>().IsPump = true;

                        foreach(var hitbox in fleebHead.GetComponents<Collider2D>()) { GameObject.Destroy(hitbox); }
                        var floop = fleebHead.AddComponent<BoxCollider2D>();
                        floop.offset = new Vector2(-0.3f, 0.02f);
                        floop.size = new Vector3(0.8f, 0.22f);

                        var fleebth = fleebHead.AddComponent<GripBehaviour>();
                        fleebth.GripPosition = new Vector3(0.15f, -0.15f, 0.45f);   
                                                                                                                  
                  }
              }
          );
         //Marine3
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Jungle Marine -AVP",
                    NameToOrderByOverride = "A",
                    DescriptionOverride = "This Marine is ready for anything",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("17.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var skin = ModAPI.LoadTexture("marine3.png");                       
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, null, null, 1);
                        person.SetBruiseColor(108, 0, 4); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(108, 0, 4); //second bruise colour. red by default
                        person.SetThirdBruiseColor(108, 0, 4); // third bruise colour. light yellow by default
                        person.SetBloodColour(108, 0, 4); // blood clour. dark red by default
                        person.SetRottenColour(0, 0, 0); // rotten/zombie colour. light yellow/green by default
                        foreach (var body in person.Limbs)
                        {
                             body.BaseStrength *= 1f;                          
                             body.Health *= 5f;
                             body.BreakingThreshold *= 1f; 
                             var ca = new GameObject("ca");
                             ca.transform.SetParent(Instance.transform.Find("Head"));
                             ca.transform.localPosition = new Vector3(0.04f, 0.08f, 0f);
                             ca.transform.localScale = new Vector3(1f, 1f);
                             var caSprite = ca.AddComponent<SpriteRenderer>();
                             caSprite.sprite = ModAPI.LoadSprite("cap.png"); 
                             ca.GetComponent<SpriteRenderer>().sortingLayerName = "Top";                                                  
                        }                    
                    }
                }
            ); 
            //Working Joe
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Android"),
                    NameOverride = "Working Joe  -AVP",
                    NameToOrderByOverride = "A",
                    DescriptionOverride = "That Android from Alien Isolation",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("23.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var skin = ModAPI.LoadTexture("droid.png");                       
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, null, null, 1);
                        person.SetBruiseColor(0, 0, 4); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(0, 0, 4); //second bruise colour. red by default
                        person.SetThirdBruiseColor(0, 0, 4); // third bruise colour. light yellow by default
                        person.SetBloodColour(0, 0, 4); // blood clour. dark red by default
                        person.SetRottenColour(0, 0, 0); // rotten/zombie colour. light yellow/green by default
                        foreach (var body in person.Limbs)
                        {
                             body.BaseStrength *= 1f;                          
                             body.Health *= 0.8f;
                             body.BreakingThreshold *= 1f;
                             body.transform.root.localScale *= 0.99f;                                                   
                        }                    
                    }
                }
            );
            //knife
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Knife"), 
                    NameOverride = "Knife from Xenomorphs tail -Avp", // Name.
                    NameToOrderByOverride = "AA1", //  
                    DescriptionOverride = "Predator Made this knife",// Description 
                    CategoryOverride = ModAPI.FindCategory("Melee"),//Category
                    ThumbnailOverride = ModAPI.LoadSprite("18.png", 5f),//Thumbnail
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("knife.png", 1f);                    
                    }
                }
            );
            //Self Destcruct
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Sticky Grenade"), 
                    NameOverride = "Predator Self Destruct device -Avp", // Name.
                    NameToOrderByOverride = "AA1", //  
                    DescriptionOverride = "BOOOM",// Description 
                    CategoryOverride = ModAPI.FindCategory("Explosives"),//Category
                    ThumbnailOverride = ModAPI.LoadSprite("26.png", 5f),//Thumbnail
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("bomb.png", 1.5f);  
                        Instance.FixColliders();                  
                    }
                }
            );
         //Log
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Wooden Pole"), 
                    NameOverride = "Jungle Log -Avp", // Name.
                    NameToOrderByOverride = "AA1", //  
                    DescriptionOverride = "dark Scary Jungle",// Description 
                    CategoryOverride = ModAPI.FindCategory("Misc."),//Category
                    ThumbnailOverride = ModAPI.LoadSprite("20.png", 5f),//Thumbnail
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("log.png", 1f);                    

                    }
                }
            );
//Facehugger Egg 2
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"), 
                    NameOverride = "Facehugger Egg Not Ready -Avp", // Name.
                    NameToOrderByOverride = "AA1", //  
                    DescriptionOverride = "No facehugger in it yet",// Description 
                    CategoryOverride = ModAPI.FindCategory("NOWHERE"),//Category
                    ThumbnailOverride = ModAPI.LoadSprite("11.png", 5f),//Thumbnail
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Gorse");
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("egg2.png", 1f);                                     
                    }
                }
            );
      //Smart Disc
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Crystal"), 
                    NameOverride = "Smart Disc -Avp", // Name.
                    NameToOrderByOverride = "AA1", //  
                    DescriptionOverride = "Predators weapon",// Description 
                    CategoryOverride = ModAPI.FindCategory("Melee"),//Category
                    ThumbnailOverride = ModAPI.LoadSprite("19.png", 5f),//Thumbnail
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("smart.png", 1f);                    
                    }
                }
            );

            //Knifee
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Knife"), 
                    NameOverride = "Military knife -Avp", // Name.
                    NameToOrderByOverride = "AA1", //  
                    DescriptionOverride = "Predators weapon",// Description 
                    CategoryOverride = ModAPI.FindCategory("Melee"),//Category
                    ThumbnailOverride = ModAPI.LoadSprite("22.png", 5f),//Thumbnail
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("knifee.png", 1f); 
                        Instance.FixColliders();
                    }
                }
            );
       //Metal
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Metal Pole"), 
                    NameOverride = "Metal Floor -Avp", // Name.
                    NameToOrderByOverride = "AA1", //  
                    DescriptionOverride = "For Marine Base",// Description 
                    CategoryOverride = ModAPI.FindCategory("Misc."),//Category
                    ThumbnailOverride = ModAPI.LoadSprite("21.png", 5f),//Thumbnail
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("metal.png", 1f);                    
                        Instance.FixColliders();
                    
   }
}
);
                //Metal2
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Metal Pole"), 
                    NameOverride = "Metal caution wall -Avp", // Name.
                    NameToOrderByOverride = "AA1", //  
                    DescriptionOverride = "Danger!",// Description 
                    CategoryOverride = ModAPI.FindCategory("Misc."),//Category
                    ThumbnailOverride = ModAPI.LoadSprite("29.png", 5f),//Thumbnail
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("blockk.png", 1f);                    
                        Instance.FixColliders();
                    
   }
}
);
                            //Jack
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"), 
                    NameOverride = "maintenance jack -Avp", // Name.
                    NameToOrderByOverride = "AA1", //  
                    DescriptionOverride = "Use at your own risk",// Description 
                    CategoryOverride = ModAPI.FindCategory("Melee"),//Category
                    ThumbnailOverride = ModAPI.LoadSprite("30.png", 5f),//Thumbnail
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("jack.png", 1.2f);                    
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 30f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                    
   }
}
);

        }
    }
}
public class podarokfake : MonoBehaviour
{
    public void Use()
    {
        StartCoroutine("Rodcraft6");
    }
    IEnumerator Rodcraft6()
    {
        yield return new WaitForSeconds(0.01f);
        //yield return new WaitForSeconds(1f);
        GameObject spawnedObj;
        spawnedObj = UnityEngine.GameObject.Instantiate(ModAPI.FindSpawnable("Facehugger (custom model) -AVP").Prefab, this.transform.position, Quaternion.Euler(0, 0, 0));
        CatalogBehaviour.PerformMod(ModAPI.FindSpawnable("Facehugger (custom model) -AVP"), spawnedObj);
        spawnedObj.transform.position = spawnedObj.transform.position;
        yield return new WaitForSeconds(0.01f);
        GameObject.Destroy(this.gameObject);

    }
}
public class podarokfake2 : MonoBehaviour
{
    public void Use()
    {
        StartCoroutine("Rodcraft6");
    }
    IEnumerator Rodcraft6()
    {
        yield return new WaitForSeconds(0.01f);
        //yield return new WaitForSeconds(1f);
        GameObject spawnedObj;
        spawnedObj = UnityEngine.GameObject.Instantiate(ModAPI.FindSpawnable("Facehugger Egg Not Ready -Avp").Prefab, this.transform.position, Quaternion.Euler(0, 0, 0));
        CatalogBehaviour.PerformMod(ModAPI.FindSpawnable("Facehugger Egg Not Ready -Avp"), spawnedObj);
        spawnedObj.transform.position = spawnedObj.transform.position;
        yield return new WaitForSeconds(0.01f);
        GameObject.Destroy(this.gameObject);

    }
}